/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

var app = {
    VERSION: '3.73',
    VERSION_NUM: 81,
    loadTime: null,
    loadNum: 0,
    loadTimeBool: null,
    msgArr: [],
    inTime: null,
    ifm: null,
    UType: '',
    apkUrl: '',
    fileEntrys: null,
    fileEntryapk: null,
    netWork: '',
    uspss: '',
    netWorkTime: null,
    loadBool: false,
    rtcCallBool: false,
    exitAppTicker: 0,
    exitApptime: null,
    JGInitBool: false,
    bullcomedb: null,
    badge: null,
    // Application Constructor
    initialize: function () {

        window.addEventListener("message", function (event) {
            if (event.data.cmd == "db") {
                that.ifm.getdb(app.bullcomedb, event.data);
            } else if (event.data.cmd == "badge") {
                that.ifm.getbadge(app.badge);
            } else if (event.data.cmd == "getfirst") {
                AliyunPush.getFirst(function (infos) {
                    that.ifm.setFirst(infos.isFirst);
                });
            } else if (event.data.cmd == "GoToSetting") {
                AliyunPush.GoToSetting(function (infos) { });
            } else if (event.data.cmd == "ReqPermissions") {
                app.ReqPermissions(event.data.perm);
            } else if (event.data.cmd == "HasPermissions") {
                app.HasPermissions(event.data.perm);
            } else if (event.data.cmd == "recorderReqPerm") {
                app.recorderReqPerm(function (value) {
                    that.ifm.recorderReqPermRet(value);
                });
            } else if (event.data.cmd == "recorderRecord") {
                app.recorderRecord(event.data.seconds, function (urls) {
                    that.ifm.recorderSuccess(urls);
                }, function (errors) {
                    that.ifm.recorderErrors(errors);
                }, function (notPerm) {
                    that.ifm.recorderPermissions(notPerm);

                });
            } else if (event.data.cmd == "recorderStop") {
                app.recorderStop(function (urls) {
                    that.ifm.recorderSuccess(urls);
                }, function (errors) {
                    that.ifm.recorderErrors(errors);
                });
            } else if (event.data.cmd == "exitApp") {
                navigator.app.exitApp();
            } else if (event.data.cmd == "changePhone") {
                $("#loadings").show();
                window.screen.lockOrientation('portrait');
                app.changePhone();
                app.changeAfter();
            } else if (event.data.cmd == 'cordovareload') {

                if (app.uspss != '') {
                    app.writeUserPass(app.uspss + "|Nolink", function () {
                        app.onDeviceReady()
                    });
                }
                else {
                    app.onDeviceReady()


                }
            }

        }, false);
        document.addEventListener('deviceready', this.onDeviceReady.bind(this), false);
        document.addEventListener("pause", this.onPause, false);
        document.addEventListener("resume", this.onResume, false);
        document.addEventListener("backbutton", function () {
            if (!app.loadBool) {
                navigator.app.exitApp()
            } else {
                app.ifm.onInterface({
                    cmd: 'backbutton',
                    value: 'back'
                });
            }
        }, false);
    },
    HasPermissions: function (value) {
        var permissions = cordova.plugins.permissions;
        permissions.hasPermission(value, function (status) {
            that.ifm.HasPermissionsSuccess(value, status.hasPermission);
        }, function () {
            that.ifm.HasPermissionsSuccess(value, false);
        });
    },
    ReqPermissions: function (value) {
        var permissions = cordova.plugins.permissions;
        permissions.requestPermission(value, function (status) {
            that.ifm.ReqPermissionsSuccess(value, status.hasPermission);
        }, function () {
            that.ifm.ReqPermissionsSuccess(value, false);
        });
    },
    onPause: function () {

        if (app.ifm) {

            app.ifm.onInterface({
                cmd: 'onPause',
                value: ''
            });
        }
        cordova.plugins.notification.badge.hasPermission(function (granted) {
            if (granted) {
                cordova.plugins.notification.badge.clear();
            }
        });
    },
    onResume: function () {
        if (app.ifm) {
            app.ifm.onInterface({
                cmd: 'onResume',
                value: ''
            });
        }
        cordova.plugins.notification.badge.hasPermission(function (granted) {
            if (granted) {
                setTimeout(function () {
                    cordova.plugins.notification.badge.clear();
                }, 2000);
            }
        });
    },
    // deviceready Event Handler
    //
    // Bind any cordova events here. Common events are:
    // 'pause', 'resume', etc.

    onReady: function () {
        //app.isPad();
        // if(CHANNEL_NOT.indexOf(app.UType)!=-1){
        //     Privacy=false;
        // }
        // if(Privacy){
        var YScontentList = new BScroll('#YScontentList', {
            scrollbar: true,
        });
        var bscroll = new BScroll('#horizontalPrivacy', {
            scrollbar: true,
            scrollY: false,
            scrollX: true,
            bounce: false,
            click: true,
        });
        var contentListtk = new BScroll('#contentListtk', {
            scrollbar: true,
        });
        var contentWinTopReturntk = document.getElementById('contentWin_topReturntk');
        console.log(contentWinTopReturntk)
        contentWinTopReturntk.addEventListener('click', function () {
            document.getElementById('contentWintk').style['display'] = 'none'
        })
        var YScontentWinReturntk = document.getElementById('YScontentWin_topReturn');
        YScontentWinReturntk.addEventListener('click', function () {
            document.getElementById('YScontentWin').style['display'] = 'none'
        })
        var that = this;

        AliyunPush.getFirst(function (infos) {

            if (infos.isFirst) {
                $("#UserAgreement").show();

                $("#U_No").unbind('click').bind('click', function () {
                    $("#disagreeBox").show();
                    $("#UserAgreementBox").hide();
                });
                $("#U_N").unbind('click').bind('click', function () {
                    navigator.app.exitApp();
                    //$("#disagreeBox").hide();
                    //$("#UserAgreementBox").show();
                });
                $("#U_Y").unbind('click').bind('click', function () {
                    $("#UserAgreement").hide();
                    AliyunPush.setFirst(function (info) {
                        that.receivedEvent('deviceready');
                    });
                });
                $("#U_Yes").unbind('click').bind('click', function () {
                    $("#UserAgreement").hide();

                    AliyunPush.setFirst(function (info) {
                        device.getInfo(function (info) {
                            var buildLabel = cordova.version;
                            device.available = true;
                            device.platform = info.platform;
                            device.version = info.version;
                            device.uuid = info.uuid;
                            device.cordova = buildLabel;
                            device.model = info.model;
                            device.isVirtual = info.isVirtual;
                            device.manufacturer = info.manufacturer || 'unknown';
                            device.serial = info.serial || 'unknown';
                            that.receivedEvent('deviceready');
                        }, function () {
                            that.receivedEvent('deviceready');
                        })

                    });
                });
                $(".yszc_win").unbind('click').bind('click', function () {
                    $("#YScontentWin").show();
                })
                $(".yhxy_win").unbind('click').bind('click', function () {
                    $("#contentWintk").show();
                })

            } else {
                $("#UserAgreement").hide();
                that.receivedEvent('deviceready');
            }
        });
        // }else{

        //     $("#UserAgreement").hide();
        //     this.receivedEvent('deviceready');
        // }
    },
    onDeviceReady: function () {
        var that = this;
        that.onReady();
    },
    //返回键
    eventBackButton: function () {
        app.ifm.onInterface({
            cmd: 'openalert',
            value: "再次点击即可退出"
        });
        document.removeEventListener("backbutton", app.eventBackButton, false); //注销返回键
        //2秒后重新注册
        var intervalID = window.setInterval(
            function () {
                window.clearInterval(intervalID);
                document.addEventListener("backbutton", app.eventBackButton, false); //返回键
            },
            2000
        );
    },
    updateApp: function () {
        that = this;
        that.loadTimeBool = setInterval(function () {
            if (that.ifm.getLoadBool()) {
                clearInterval(that.loadTimeBool);

                cordova.getAppVersion.getVersionCode(function (version) {

                    cordovaHTTP.get("https://download.bullcome.com/an/appUp.json", {}, {
                        Authorization: "OAuth2: token"
                    }, function (result) {
                        var objs = JSON.parse(result.data);
                        //alert(version+"==="+objs.versionCode);
                        if (parseInt(version) < parseInt(objs.versionCode)) {
                            //检测到更新时，提示用户是否升级
                            window.resolveLocalFileSystemURL(cordova.file.externalDataDirectory, function (rootDirEntry) {
                                rootDirEntry.getFile("bullcomeapk.apk", {
                                    create: true,
                                    exclusive: false
                                }, function (fileEntry) {
                                    app.fileEntryapk = fileEntry;
                                    that.ifm.onInterface({
                                        cmd: 'updateApp',
                                        value: result.data
                                    });
                                    app.apkUrl = objs.apk.replace('{0}', app.UType);
                                }, function () { });
                            }, function () { });

                        }
                    }, function (error) {
                        console.log(error);
                    });
                });

            }
        }, 1000 * 1);
    },
    setPhoneClient: function () {
        // this.ifm.onbullcomedb(app.bullcomedb);
        this.ifm.onInterface({
            cmd: 'phoneClient',
            value: true
        });

        if (app.UType != '')

            that.ifm.onInterface({
                cmd: 'setUserType',
                value: app.UType
            });
        this.inTime = setInterval(app.pInterface, 100)
    },
    updateDownload: function (url) {
        var fileTransfer = new FileTransfer();
        var uri = encodeURI(url);
        var tempn = 0;
        fileTransfer.onprogress = function (progressEvent) {
            if (progressEvent.lengthComputable) {
                var downloadProgress = Math.floor((progressEvent.loaded / progressEvent.total) * 100);
                if (tempn < downloadProgress && downloadProgress < 99) {
                    that.ifm.onInterface({
                        cmd: 'onprogress',
                        value: downloadProgress
                    });
                    tempn = downloadProgress;
                } else {

                }

            } else {

            }
        };
        fileTransfer.download(
            uri,
            app.fileEntryapk.toURL(),
            function (entry) {

                cordova.plugins.fileOpener2.open(
                    entry.toInternalURL(),
                    'application/vnd.android.package-archive', {
                    success: function () { },
                    error: function (e) { }
                }
                );
            },
            function (error) {

            },
            true
        );
    },
    pInterface: function () {
        var retArr = app.ifm.inInterface();
        var i = 0
        while (retArr.length > 0) {
            var unit = retArr[0];
            retArr.pop();

            switch (unit[0]) {
                case 'setTags':
                    app.setTags(unit[1]);
                    break;
                case 'delTags':
                    app.delTags(unit[1]);
                    break;
                // case 'updateApp':
                //     app.updateDownload(app.apkUrl);
                //     break;
                case 'orientationlock':
                    window.screen.lockOrientation(unit[1]);
                    break;
                case 'wxPay':
                    app.wxPay(unit[1]);
                    break;
                case 'alipay':
                    app.alipay(unit[1]);
                    break;
                case 'writeUserPass':
                    app.writeUserPass(unit[1]);
                    break;
                case 'subscribeMessage':
                    app.subscribeMessage(unit[1]);
                    break;
                case 'wxOpenCustomerServiceChat':
                    app.wxOpenCustomerServiceChat(unit[1]);    
                    break;
                case 'contactsCreate':
                    app.contactsCreate(unit[1]);
                    break;
                case 'jumpToBizProfile':
                    app.jumpToBizProfile(unit[1]);
                    break;
                case 'share':
                    app.share(unit[1]);
                    break;
                case 'shareSession':
                    app.shareSession(unit[1]);
                    break;
                case 'auth':
                    app.auth(unit[1]);
                    break;
                case 'getDdevice':
                    app.getDdevice(unit[1]);
                    break;
                case 'screenshots':
                    app.screenshots(unit[1]);
                    break;
                case 'screenshotUrl':
                    app.screenshotUrl(unit[1]);
                    break;
                case "VERSION_NUM":

                    app.ifm.onInterface({
                        cmd: 'VERSION_NUM',
                        value: app.VERSION_NUM
                    });
                    break;
                case 'openMiniProgram':
                    app.openMiniProgram(unit[1])
                    break;
                case 'StatusBarColor':
                    app.StatusBarColor(unit[1])
                    break;
                case 'StatusBaroverlaysWebView':
                    app.StatusBaroverlaysWebView(unit[1])
                    break;
                case 'StatusBarstyleDefault':
                    app.StatusBarstyleDefault()
                    break;
                case 'StatusBarstyleBlackTranslucent':
                    app.StatusBarstyleBlackTranslucent()
                    break;
                case 'StatusBarstyleBlackOpaque':
                    app.StatusBarstyleBlackOpaque()
                    break;
                case 'StatusBarstyleLightContent':
                    app.StatusBarstyleLightContent()
                    break;
                case 'StatusBarhide':
                    app.StatusBarhide()
                    break;
                case 'StatusBarshow':
                    app.StatusBarshow()
                    break;
                case 'takePhoto':

                    app.takePhoto(unit[1]);
                    break;
                case 'takefromgalery':
                    app.takefromgalery(unit[1]);
                    break;
                case 'JGloginAuth':
                    app.JGloginAuth(unit[1]);
                    break;
                case 'JGsetCustomUIWithConfig':
                    app.JGsetCustomUIWithConfig(unit[1]);
                    break;
                case 'AppBrowser':
                    app.AppBrowser(unit[1],unit[2]);
                    break;
                case 'JGcheckVerifyEnable':
                    app.JGcheckVerifyEnable();
                    break;
                case 'cordovareload':
                    if (app.uspss != '') {
                        app.writeUserPass(app.uspss + "|Nolink", function () {
                            // setTimeout(function () {
                            //     window.location.reload();
                            // }, 1000);
                            app.onDeviceReady()
                        });
                    }
                    else {
                        app.onDeviceReady()
                    }
                    break;
                case 'removebackbutton':
                    document.removeEventListener('backbutton');
                    app.ifm.onInterface({
                        cmd: 'removebackbutton',
                        value: unit[1]
                    });
                    break;
                case 'shareToWeibo':
                    app.shareToWeibo(unit[1]);
                    break;
                case 'shareImageToWeibo':
                    app.shareImageToWeibo(unit[1]);
                    break;
                case 'shareTextToWeibo':
                    app.shareTextToWeibo(unit[1]);
                    break;
                case 'weibocheckClientInstalled':
                    app.weibocheckClientInstalled();
                    break;
                case 'rtcCall':
                    app.rtcCall(unit[1]);
                    break;
                case 'coolMethod':
                    app.coolMethod(unit[1]);
                    break;
                case 'getRegisterId':
                    app.getRegisterId();
                    break;
                case 'bindAccount':
                    app.bindAccount(unit[1]);
                    break;
                case 'unbindAccount':
                    app.unbindAccount();
                    break;
                case 'addAlias':
                    app.addAlias(unit[1]);
                    break;
                case 'removeAlias':
                    app.removeAlias(unit[1]);
                    break;
                case 'listAliases':
                    app.listAliases();
                    break;
                case 'bindTags':
                    app.bindTags(unit[1]);
                    break;
                case 'unbindTags':
                    app.unbindTags(unit[1]);
                    break;
                case 'listTags':
                    app.listTags();
                    break;
                case "requireNotifyPermission":
                    app.requireNotifyPermission(unit[1]);
                    break;
                case "isEnableNotification":
                    app.isEnableNotification();
                    break;
                case "JGInit":
                    app.JGInit();
                    break;
                case "exitApp":
                    navigator.app.exitApp()
                    break;
                case "readUserPass":
                    app.readUserPass();
                    break;
                // case 'getPictures':
                //     app.getPictures();
                //     break;
                default:
                    break;
            }

        }
    },
    JGInit: function () {

        if (JGJVerificationPlugin && !app.JGInitBool) {
            JGJVerificationPlugin.setDebugMode(true);
            JGJVerificationPlugin.init();
            app.JGInitBool = true;
        }
    },
    JGcheckVerifyEnable: function () {
        JGJVerificationPlugin.checkVerifyEnable(function (msg) {
            app.ifm.onInterface({
                cmd: 'JGcheckVerifyEnable',
                value: msg
            });
        })
    },
    JGsetCustomUIWithConfig(json) {
        JGJVerificationPlugin.setCustomUIWithConfig(json, function (msg) {
            app.ifm.onInterface({
                cmd: 'JGloginAuthOther',
                value: msg
            });

        });
    },
    JGloginAuth: function (json) {
        //JGJVerificationPlugin.setDialogTheme()

        JGJVerificationPlugin.setCustomUIWithConfig(json, function (msg) {
            app.ifm.onInterface({
                cmd: 'JGloginAuthOther',
                value: msg
            });

        });
        JGJVerificationPlugin.loginAuth(true, function (msg) {
            app.ifm.onInterface({
                cmd: 'JGloginAuthSuccess',
                value: msg
            });

        })
    },
    alipay: function (payInfo) {

        cordova.plugins.alipay.payment(payInfo, function success(e) {
            if (e.resultStatus == "9000") {
                app.ifm.onInterface({
                    cmd: 'alipaySuccess',
                    value: JSON.stringify(e.result)
                });
            }
        }, function error(e) {
            app.ifm.onInterface({
                cmd: 'alipayFailed',
                value: e.resultStatus
            });
        });

        //e.resultStatus  状态代码  e.result  本次操作返回的结果数据 e.memo 提示信息
        //e.resultStatus  9000  订单支付成功 ;8000 正在处理中  调用function success
        //e.resultStatus  4000  订单支付失败 ;6001  用户中途取消 ;6002 网络连接出错  调用function error
        //当e.resultStatus为9000时，请去服务端验证支付结果
        /**
         * 同步返回的结果必须放置到服务端进行验证（验证的规则请看https://doc.open.alipay.com/doc2/
         * detail.htm?spm=0.0.0.0.xdvAU6&treeId=59&articleId=103665&
         * docType=1) 建议商户依赖异步通知
         */
    },
    StatusBarColor: function (value) {
        StatusBar.backgroundColorByHexString(value);
    },
    StatusBaroverlaysWebView(value) {
        StatusBar.overlaysWebView(value);
    },
    StatusBarstyleDefault() {
        StatusBar.styleDefault();
    },
    StatusBarstyleBlackTranslucent() {
        StatusBar.styleBlackTranslucent();
    },
    StatusBarstyleBlackOpaque() {
        StatusBar.styleBlackOpaque();
    },
    StatusBarstyleLightContent() {
        StatusBar.styleLightContent();
    },

    StatusBarhide() {
        StatusBar.hide();
    },
    StatusBarshow() {
        StatusBar.show();
    },
    wxPay: function (value) {
        var timestamp = Date.parse(new Date());
        timestamp = timestamp / 1000;
        var pay = JSON.parse(value);
        var params = {
            appid: pay.appid,
            partnerid: pay.partnerid, // merchant id
            prepayid: pay.prepayid, // prepay id
            noncestr: pay.noncestr, // nonce
            timestamp: pay.timestamp, // timestamp
            sign: pay.sign // signed string
        };
        Wechat.sendPaymentRequest(params, function () {

            app.ifm.onInterface({
                cmd: 'openalert',
                value: "支付成功！"
            });
            //alert("Success");
        }, function (reason) {
            app.ifm.onInterface({
                cmd: 'openalert',
                value: "支付失败，请重新支付！"
            });

        });
    },
    openMiniProgram: function (value) {
        var params = JSON.parse(value);
        Wechat.openMiniProgram(params, function (data) {
            app.ifm.onInterface({
                cmd: 'openMiniProgram',
                value: JSON.stringify(data)
            });
            //console.log(data); // data:{extMsg:""}  extMsg: Corresponds to the app-parameter attribute in the Mini Program component <button open-type="launchApp">
        }, function () {
            app.ifm.onInterface({
                cmd: 'openMiniProgramError',
                value: "openMiniProgramError"
            });
        })
    },
    getDdevice: function () {

        app.ifm.onInterface({
            cmd: 'getDdevice',
            value: JSON.stringify(device)
        });
    },
    // SimInfo: function (value) {
    //     window.plugins.sim.getSimInfo(function (result) {

    //     }, function (error) {


    //     });
    // },
    auth: function () {

        var scope = "snsapi_userinfo",
            state = "_" + (+new Date());
        Wechat.auth(scope, state, function (response) {
            app.ifm.onInterface({
                cmd: 'authSuccess',
                value: JSON.stringify(response)
            });
        }, function (reason) {
            app.ifm.onInterface({
                cmd: 'authFailed',
                value: JSON.stringify(reason)
            });
        });
    },
    screenshots: function (value) {
        navigator.screenshot.save(function (error, res) {
            if (error) {
                app.ifm.onInterface({
                    cmd: 'screenshotFailed',
                    value: JSON.stringify(error)
                });

            } else {
                app.ifm.onInterface({
                    cmd: 'screenshotSuccess',
                    value: res.filePath
                });
            }
        }, 'jpg', 50, value);
    },
    aloss: function (scrs, files) {
        var client = new OSS({
            region: scrs.region,
            accessKeyId: scrs.accessKeyId,
            accessKeySecret: scrs.accessKeySecret,
            bucket: scrs.bucket
        });
        client.multipartUpload(scrs.path, files).then(function (result) {
            app.ifm.onInterface({
                cmd: 'screenshotURLSuccess',
                value: JSON.stringify({
                    path: scrs.path,
                    fname: scrs.fname
                })
            });
        }).catch(function (err) {
            app.ifm.onInterface({
                cmd: 'screenshotURLFailed',
                value: JSON.stringify(err)
            });
        });

    },


    dataURItoBlob: function (dataURI) {
        var byteString;
        if (dataURI.split(',')[0].indexOf('base64') >= 0) {
            byteString = atob(dataURI.split(',')[1]);
        } else byteString = unescape(dataURI.split(',')[1]);

        var mimeString = dataURI.split(',')[0].split(':')[1].split(';')[0];
        var ia = new Uint8Array(byteString.length);
        for (var i = 0; i < byteString.length; i++) {
            ia[i] = byteString.charCodeAt(i);
        }
        return new Blob([ia], {
            type: mimeString
        });
    },
    screenshotUrl: function (value) {
        var scrs = JSON.parse(value);
        navigator.screenshot.URI(function (error, res) {
            if (error) {
                app.ifm.onInterface({
                    cmd: 'screenshotURLFailed',
                    value: JSON.stringify(error)
                });

            } else {
                app.aloss(scrs, app.dataURItoBlob(res.URI));

            }
        }, 'jpg', 40, scrs.fname);
    },
    shareToWeibo: function (value) {
        var args = JSON.parse(value);
        // WeiboSDK.shareToWeibo(function () {
        //     app.ifm.onInterface({
        //         cmd: 'shareToWeiboSuccess',
        //         value: ""
        //     });
        // }, function (failReason) {
        //     app.ifm.onInterface({
        //         cmd: 'shareToWeiboFailed',
        //         value: ""
        //     });

        // }, args);
    },
    shareImageToWeibo: function (value) {
        var args = JSON.parse(value);
        // WeiboSDK.shareImageToWeibo(function () {
        //     app.ifm.onInterface({
        //         cmd: 'shareToWeiboSuccess',
        //         value: ""
        //     });
        // }, function (failReason) {
        //     app.ifm.onInterface({
        //         cmd: 'shareToWeiboFailed',
        //         value: ""
        //     });
        // }, args);
    },
    shareTextToWeibo: function (value) {
        var args = JSON.parse(value);
        // WeiboSDK.shareTextToWeibo(function () {
        //     app.ifm.onInterface({
        //         cmd: 'shareToWeiboSuccess',
        //         value: ""
        //     });
        // }, function (failReason) {
        //     app.ifm.onInterface({
        //         cmd: 'shareToWeiboFailed',
        //         value: ""
        //     });
        // }, args);
    },
    weibocheckClientInstalled: function () {

        // WeiboSDK.checkClientInstalled(function () {

        //     app.ifm.onInterface({
        //         cmd: 'weibocheckClientSuccess',
        //         value: ""
        //     });
        // }, function () {

        //     app.ifm.onInterface({
        //         cmd: 'weibocheckClientFailed',
        //         value: ""
        //     });
        // });
    },
    shareOBJ: function (value) {


        Wechat.share({
            message: value,
            scene: Wechat.Scene.TIMELINE // share to Timeline
        }, function () {
            app.ifm.onInterface({
                cmd: 'shareSuccess',
                value: value
            });
        }, function (reason) {
            app.ifm.onInterface({
                cmd: 'shareFailed',
                value: value
            });
        });
    },
    share: function (value) {
        var message;
        if (value != "") {
            message = JSON.parse(value);
        }
        Wechat.share({
            message: message,
            scene: Wechat.Scene.TIMELINE // share to Timeline
        }, function () {

            app.ifm.onInterface({
                cmd: 'shareSuccess',
                value: value
            });
        }, function (reason) {

            app.ifm.onInterface({
                cmd: 'shareFailed',
                value: value
            });
        });
    },
    shareSession: function (value) {
        var message;
        if (value != "") {
            message = JSON.parse(value);
        }
        Wechat.share({
            message: message,
            scene: Wechat.Scene.SESSION // share to Timeline
        }, function () {
            app.ifm.onInterface({
                cmd: 'shareSessionSuccess',
                value: value
            });
        }, function (reason) {
            app.ifm.onInterface({
                cmd: 'shareSessionFailed',
                value: value
            });
        });
    },
    jumpToBizProfile: function (value) {

        var params;

        if (value != "") {
            params = JSON.parse(value);
        }

        if (params) {

            Wechat.jumpToBizProfile(params, function (response) {
                app.ifm.onInterface({
                    cmd: 'jumpToBizProfileSuccess',
                    value: response
                });
            }, function (value) {
                app.ifm.onInterface({
                    cmd: 'jumpToBizProfileFailed',
                    value: reason
                });

            });
        } else {
            app.ifm.onInterface({
                cmd: 'jumpToBizProfileFailed',
                value: "params null"
            });
        }
    },
    wxOpenCustomerServiceChat:function(value) {
        var params;
        if (value != "") {
            params = JSON.parse(value);
        }
        if (params) {
            Wechat.wxOpenCustomerServiceChat(params, function (response) {

                app.ifm.onInterface({
                    cmd: 'wxOpenCustomerServiceChatSuccess',
                    value: response
                });
            }, function (value) {

                app.ifm.onInterface({
                    cmd: 'wxOpenCustomerServiceChatFailed',
                    value: reason
                });

            });
        } else {

            app.ifm.onInterface({
                cmd: 'wxOpenCustomerServiceChatFailed',
                value: "params null"
            });
        }
    },
    subscribeMessage: function (value) {
        var params;
        if (value != "") {
            params = JSON.parse(value);
        }
        if (params) {

            Wechat.subscribeMessage(params, function (response) {

                app.ifm.onInterface({
                    cmd: 'subscribeMessageSuccess',
                    value: response
                });
            }, function (value) {

                app.ifm.onInterface({
                    cmd: 'subscribeMessageFailed',
                    value: reason
                });

            });
        } else {

            app.ifm.onInterface({
                cmd: 'subscribeMessageFailed',
                value: "params null"
            });
        }
    },

    setTags: function (value) {
        if (value != '') {
            var vl = value.split(';')
            window.baidupush.setTags(vl, function (info) { });
        }
    },
    delTags: function (value) {
        if (value != '') {
            var vl = value.split(';')
            window.baidupush.delTags(vl, function (info) { });
        }
    },
    permissionsSuccess: function (status) {
        if (!status.hasPermission) app.permissionsError();
    },
    permissionsError: function () {
        //alert("permissionsError");
    },
    readUserPass: function () {

        window.resolveLocalFileSystemURL(cordova.file.externalRootDirectory, function (dirEntry) {

            app.createDirectory(dirEntry);
        }, app.onErrorLoadFs);

    },
    initPush: function () {
        that = this;
        var alipays = "f";
        if (cordova.plugins.alipay) {
            alipays = "s";
        }
        that.ifm.onInterface({
            cmd: 'alipay',
            value: alipays
        });
        if (Wechat) {
            Wechat.isInstalled(function (installed) {
                that.ifm.onInterface({
                    cmd: 'wxins',
                    value: "s"
                });
                that.ifm.onInterface({
                    cmd: 'weixin',
                    value: "s"
                });
            }, function (reason) {
                that.ifm.onInterface({
                    cmd: 'wxins',
                    value: "f"
                });
                that.ifm.onInterface({
                    cmd: 'weixin',
                    value: "f"
                });
            });

        };
        app.weibocheckClientInstalled();
        var permissions = cordova.plugins.permissions;

        permissions.hasPermission(permissions.READ_EXTERNAL_STORAGE, function (status) {

            // if (status.hasPermission) {
            //     app.readUserPass();

            // } else {

            //     AliyunPush.getFirstDate(function (infos) {
            //         if (infos.isFirst) {
            //             AliyunPush.setFirstDate(function (infost) { });
            //         }
            //     });
            // }
            if (!status.hasPermission) {
                AliyunPush.getFirstDate(function (infos) {
                    if (infos.isFirst) {
                        AliyunPush.setFirstDate(function (infost) { });
                    }
                });
            }
        });

    },

    createDirectoryWrite: function (rootDirEntry, fun) {
        rootDirEntry.getDirectory('com', {
            create: true
        }, function (dirEntry) {
            dirEntry.getDirectory('bullcome', {
                create: true
            }, function (subDirEntry) {
                app.createFileWrite(subDirEntry, "passU.data", fun);
            }, app.onErrorGetDir);
        }, app.onErrorGetDir);
    },
    createDirectory: function (rootDirEntry) {
        rootDirEntry.getDirectory('com', {
            create: true
        }, function (dirEntry) {
            dirEntry.getDirectory('bullcome', {
                create: true
            }, function (subDirEntry) {
                app.createFile(subDirEntry, "passU.data");
            }, app.onErrorGetDir);
        }, app.onErrorGetDir);
    },
    bindAccount: function (account) {
        AliyunPush.bindAccount(account, function (infos) {
            app.ifm.onInterface({
                cmd: 'bindAccountSuccess',
                value: account
            });
        }, function (err) {

        });
    },
    unbindAccount: function () {
        AliyunPush.unbindAccount(function (infos) {
            app.ifm.onInterface({
                cmd: 'unbindAccountSuccess',
                value: account
            });
        }, function (err) {

        });
    },
    addAlias: function (alias) {
        AliyunPush.addAlias(alias, function (infos) {
            app.ifm.onInterface({
                cmd: 'addAliasSuccess',
                value: alias
            });
        }, function (err) {

        });
    },
    removeAlias: function (alias) {
        AliyunPush.removeAlias(alias, function (infos) {
            app.ifm.onInterface({
                cmd: 'removeAliasSuccess',
                value: alias
            });
        }, function (err) {

        });
    },
    listAliases: function () {
        AliyunPush.listAliases(function (infos) {
            app.ifm.onInterface({
                cmd: 'listAliasesSuccess',
                value: JSON.stringify(infos)
            });
        }, function (err) {

        });
    },
    requireNotifyPermission: function (msg) {
        AliyunPush.requireNotifyPermission(function (infos) {
            app.ifm.onInterface({
                cmd: 'requireNotifyPermissionSuccess',
                value: ""
            });
        }, function (err) {

        });
    },
    isEnableNotification: function () {
        AliyunPush.isEnableNotification(function (infos) {
            app.ifm.onInterface({
                cmd: 'isEnableNotificationSuccess',
                value: JSON.stringify(infos)
            });
            if (infos.enable) {
                cordova.plugins.notification.badge.set(1);

            }

        });
    },
    bindTags: function (tags) {
        AliyunPush.bindTags(tags, function (infos) {
            app.ifm.onInterface({
                cmd: 'bindTagsSuccess',
                value: tags
            });
        }, function (err) {

        });
    },
    unbindTags: function (tags) {
        AliyunPush.unbindTags(tags, function (infos) {
            app.ifm.onInterface({
                cmd: 'unbindTagsSuccess',
                value: tags
            });
        }, function (err) {

        });
    },
    listTags: function () {
        AliyunPush.listTags(function (infos) {
            app.ifm.onInterface({
                cmd: 'listTagsSuccess',
                value: JSON.stringify(info)
            });
        }, function (err) {

        });
    },
    getRegisterId: function () {
        AliyunPush.getRegisterId(function (infos) {
            app.ifm.onInterface({
                cmd: 'getRegisterIdSuccess',
                value: infos
            });
        }, function (err) {
            app.ifm.onInterface({
                cmd: 'getRegisterIdFailed',
                value: err
            });
        });
    },

    // getPictures:function(){
    //     window.imagePicker.getPictures(
    //         function(results) {
    //             app.ifm.onInterface({
    //                 cmd: 'getPicturesSuccess',
    //                 value: JSON.stringify(results)
    //             });
    //         }, function (error) {
    //             app.ifm.onInterface({
    //                 cmd: 'getPicturesFailed',
    //                 value: JSON.stringify(err)
    //             });
    //         }, {
    //             maximumImagesCount: 10,
    //             width: 800,
    //             quality:100
    //         }
    //     );
    // },
    rtcCall: function (value) {
        params = JSON.parse(value);
        cordova.plugins.AliRtcPlugin.rtcCall(params, function (infos) {
            app.rtcCallBool = true;
            if (infos == "outRTC") {
                app.rtcCallBool = false;
            }
            app.ifm.onInterface({
                cmd: 'rtcCall',
                value: infos
            });
        }, function (err) {
            app.ifm.onInterface({
                cmd: 'rtcCall',
                value: err
            });
        });
    },
    isPad: function () {
        cordova.plugins.AliRtcPlugin.isPad("", function (infos) {
            alert(infos.isPad);
        }, function (err) {

        });
    },
    coolMethod: function (value) {
        // if (app.rtcCallBool) {
        params = JSON.parse(value);
        cordova.plugins.AliRtcPlugin.coolMethod(params, function (infos) {
            app.ifm.onInterface({
                cmd: 'coolMethod',
                value: infos
            });
        }, function (err) {
            app.ifm.onInterface({
                cmd: 'coolMethod',
                value: err
            });
        });
        //}
        // else{
        //     app.ifm.onInterface({
        //         cmd: 'coolMethod',
        //         value: app.rtcCallBool
        //     });
        // }
    },
    AppBrowser:function(url,target) {
        var options = "location=yes";
        cordova.InAppBrowser.open(url, target, options);
       
    },
    contactsCreate: function (value) {

        params = JSON.parse(value);

        app.contact = navigator.contacts.create({
            displayName: params.name,
            phoneNumbers: [{
                value: params.phone
            }]
        });
        //保存处理
        app.contact.save(function () {
            app.ifm.onInterface({
                cmd: 'createPhone',
                value: "Success"
            });
        }, function (err) {
            app.ifm.onInterface({
                cmd: 'createPhone',
                value: "fail"
            });
        });




    },
    alossTake: function (scrs, files) {
        var client = new OSS({
            region: scrs.region,
            accessKeyId: scrs.accessKeyId,
            accessKeySecret: scrs.accessKeySecret,
            bucket: scrs.bucket
        });
        client.multipartUpload(scrs.path, files).then(function (result) {
            app.ifm.onInterface({
                cmd: 'takeURLSuccess',
                value: JSON.stringify({
                    path: scrs.path,
                    fname: scrs.fname
                })
            });
        }).catch(function (err) {
            app.ifm.onInterface({
                cmd: 'takeURLFailed',
                value: JSON.stringify(err)
            });
        });

    },
    takePhoto: function (value) {

        var op = JSON.parse(value);
        var cop = op.cameraOptions;
        var cameraOptions = {
            quality: cop.quality,
            destinationType: cop.destinationType,
            //sourceType: Camera.PictureSourceType.CAMERA,     //照相机类型
            sourceType: cop.sourceType,
            allowEdit: cop.allowEdit,
            encodingType: cop.encodingType,
            mediaType: Camera.MediaType.PICTURE,
            targetWdith: cop.targetWdith,
            targetHeight: cop.targetHeight,

            popoverOptions: CameraPopoverOptions,
            saveToPhotoAlbum: cop.saveToPhotoAlbum
        };
        navigator.camera.getPicture(function (imageURL) {
            app.alossTake(op.scre, app.dataURItoBlob("data:image/jpeg;base64," + imageURL));
        }, function (e) {
            app.ifm.onInterface({
                cmd: 'takeURLFailed',
                value: e
            });
        }, cameraOptions);
    },
    createFileWrite: function (dirEntry, fileName, fun) {

        dirEntry.getFile(fileName, {
            create: true,
            exclusive: false
        }, function (fileEntry) {
            app.fileEntrys = fileEntry;
            if (fun) {
                fun();
            }
        }, app.onErrorCreateFile);

    },
    createFile: function (dirEntry, fileName) {

        dirEntry.getFile(fileName, {
            create: true,
            exclusive: false
        }, function (fileEntry) {

            app.fileEntrys = fileEntry;
            app.readFile(fileEntry);
        }, app.onErrorCreateFile);

    },
    writeReqPerm: function (Perm) {
        var permissions = cordova.plugins.permissions;
        var list = [
            permissions.WRITE_EXTERNAL_STORAGE,
            permissions.READ_EXTERNAL_STORAGE
        ];
        permissions.requestPermissions(list, function (status) {
            if (status.hasPermission) {
                if (Perm) Perm(true);
            } else {
                if (Perm) Perm(false);
            }
        });
    },
    writeUserPass: function (value, fun) {
        that = this;
        app.writeReqPerm(function (status) {
            if (status) {
                window.resolveLocalFileSystemURL(cordova.file.externalRootDirectory, function (dirEntry) {
                    app.createDirectoryWrite(dirEntry, function () {
                        if (app.fileEntrys)
                            app.writeFile(app.fileEntrys, new Blob([value], {
                                type: 'text/plain'
                            }), false, fun);
                    });
                }, app.onErrorLoadFs);
            } else {
                that.ifm.onInterface({
                    cmd: 'readU',
                    value: "NO"
                });
            }
        });


    },
    writeFile: function (fileEntry, dataObj, isAppend, fun) {
        // Create a FileWriter object for our FileEntry (log.txt).
        fileEntry.createWriter(function (fileWriter) {
            fileWriter.onwriteend = function () {
                console.log("Successful file write...");
                //app.readFile(fileEntry);
            };
            fileWriter.onerror = function (e) {
                console.log("Failed file write: " + e.toString());
            };
            if (isAppend) {
                try {
                    fileWriter.seek(fileWriter.length);
                } catch (e) {
                    console.log("file doesn't exist!");
                }
            }

            fileWriter.write(dataObj);
            if (fun) fun();
        });
    },
    readFile: function (fileEntry) {

        fileEntry.file(function (file) {
            var reader = new FileReader();
            reader.onloadend = function () {
                app.displayFileData(this.result);
            };
            reader.readAsText(file);
        }, app.onErrorReadFile);
    },
    displayFileData: function (value) {
        if (value) {
            that = this;
            var arrValue = value.split("|");
            if (arrValue.length >= 2) {
                app.uspss = value;

                that.ifm.onInterface({
                    cmd: 'readU',
                    value: value
                });
            } else {
                app.ifm.onInterface({
                    cmd: 'openalert',
                    value: "onErrorReadFileNull"
                });
            }

        }
        else {
            app.ifm.onInterface({
                cmd: 'openalert',
                value: "onErrorReadFileNull"
            });
        }
    },
    onErrorGetDir: function () {
        app.ifm.onInterface({
            cmd: 'openalert',
            value: "onErrorReadFileNull"
        });
        // app.ifm.onInterface({
        //     cmd: 'openalert',
        //     value: "没有获取存储权限，为了您有更好的体验请始终允许。"
        // })
    },
    onErrorLoadFs: function () {
        app.ifm.onInterface({
            cmd: 'openalert',
            value: "onErrorLoadFs"
        })
    },
    onErrorCreateFile: function () {
        app.ifm.onInterface({
            cmd: 'openalert',
            value: "onErrorCreateFile"
        })
    },
    onErrorReadFile: function () {
        app.ifm.onInterface({
            cmd: 'openalert',
            value: "onErrorReadFile"
        });
    },
    notificationClicked: function (info) {
        app.ifm.onInterface({
            cmd: 'showMsgs',
            value: info.data
        });
    },
    recorderStop: function (success, error) {
        window.plugins.audioRecorderAPI.stop(function (msg) {
            // success
            if (msg.cmd == "success") {
                if (success) success(msg.path);
            }
        }, function (msg) {
            if (error) error(msg);
        });
    },
    recorderReqPerm: function (Perm) {
        var permissions = cordova.plugins.permissions;
        var list = [
            permissions.WRITE_EXTERNAL_STORAGE,
            permissions.RECORD_AUDIO
        ];
        permissions.requestPermissions(list, function (status) {
            if (status.hasPermission) {
                if (Perm) Perm(true);
            } else {
                if (Perm) Perm(false);
            }
        });
    },
    recorderRecord: function (seconds, success, error, notPerm) {
        if (!seconds) seconds = 30;
        var permissions = cordova.plugins.permissions;
        var list = [
            permissions.WRITE_EXTERNAL_STORAGE,
            permissions.RECORD_AUDIO
        ];
        permissions.requestPermissions(list, function (status) {
            if (status.hasPermission) {
                window.plugins.audioRecorderAPI.record(function (msg) {
                    if (msg.cmd == "success") {
                        if (success) success(msg.path);
                    }
                }, function (msg) {

                    if (error) error("error");
                }, seconds); // record 30 seconds               
            } else {
                if (notPerm) notPerm("not_permissions");
            }
        }, function () {
            if (error) error("error_permissions");
        });


    },
    recorderPlayback: function () {
        window.plugins.audioRecorderAPI.playback(function (msg) {

            // complete
            //alert('ok: ' + msg);
        }, function (msg) {
            // failed
            console.warn(msg);
        });
    },
    init: function () {
        this.setPhoneClient();
        this.initPush();
        $("#loadings").hide();
        //$("#loadings").html('');

        //this.updateApp();
    },
    Onoffline: function () {
        window.clearInterval(app.netWorkTime);
        var networkStates = navigator.connection.type;
        if (networkStates == Connection.NONE) {
            app.netWorkTime = setTimeout(function () {
                $("#mainHtml").attr("src", 'file:///android_asset/www/index/index.html');
                app.netWork = Connection.NONE;
                app.loadBool = false;
            }, 8000);
        }
    },
    Ononline: function () {
        window.clearInterval(app.netWorkTime);
        //alert(app.netWork);
        //alert(navigator.connection.type);
        if (navigator.connection.type != app.netWork && app.netWork == Connection.NONE) {
            if (navigator.connection.type != Connection.NONE) {
                //$("#mainHtml").attr("src", 'https://m.bullcome.com/');
                //$("#mainHtml").attr("src", 'file:///android_asset/www/phone/bullcome.html');
                cordova.plugins.AliRtcPlugin.isPad("", function (infos) {
                    if (infos.isPad) {
                        app.changeiPad();
                    } else {
                        app.changePhone();
                    }
                    app.changeAfter();
                }, function (err) {
                    app.changePhone();
                    app.changeAfter();
                });
            }
        }
        app.netWork = navigator.connection.type;
    },
    timeout: 0,
    changePhone: function () {
        window.screen.lockOrientation('portrait');
       $("#mainHtml").attr("src", 'https://m.bullcome.com/?v=' + (new Date()).getTime());
        // $("#mainHtml").attr("src", 'file:///android_asset/www/phone/bullcome.html');
        app.timeout = setTimeout(function () {
            $("#mainHtml").attr("src", 'file:///android_asset/www/phone/bullcome.html');
            $("#loadings").hide();
            //$("#loadings").html('');
        }, 15 * 1000);
     
        app.loadBool = false;
    },
    changeiPad: function () {
        window.screen.lockOrientation('landscape');
     
        $("#mainHtml").attr("src", 'https://m.bullcome.com/ipad/?v=' + (new Date()).getTime());
      
        app.timeout = setTimeout(function () {
            $("#mainHtml").attr("src", 'https://m.bullcome.com/ipad/?v=' + (new Date()).getTime());
            $("#loadings").hide();
            //$("#loadings").html('');
        }, 15 * 1000);
        app.loadBool = false;
    },
    changeAfter: function () {
        var that = app;
        app.bullcomedb = window.sqlitePlugin.openDatabase({
            name: 'bullcomedb.db',
            location: 'default',
            androidDatabaseProvider: 'system'
        });
        cordova.plugins.notification.badge.hasPermission(function (granted) {
            if (granted) {
                app.badge = cordova.plugins.notification.badge;
            }
        });
        $("#mainHtml").load(function () {
            if ($("#mainHtml").attr("src").indexOf('m.bullcome.com') != -1 || $("#mainHtml").attr("src").indexOf('bullcome.html') != -1 || $("#mainHtml").attr("src").indexOf('192.168.1') != -1 || $("#mainHtml").attr("src").indexOf('192.168.3') != -1) {
                var loadTime = setInterval(function () {
                    app.ifm = $("#mainHtml")[0].contentWindow.inf;
                    if (app.ifm) {
                        if (!app.loadBool) app.init();
                        app.loadBool = true;
                        clearInterval(app.timeout);
                        clearInterval(loadTime);
                        if (app.msgArr.length > 0) {
                            app.ifm.onInterface({
                                cmd: 'PushMessageSuccess',
                                value: JSON.stringify(app.msgArr[0])
                            });
                            app.msgArr = [];
                        }


                    }
                }, 100)
            }
        });
    },
    // Update DOM on a Received Event
    receivedEvent: function (id) {
        AliyunPush.initPush(function (infos) {

            cordova.plugins.notification.badge.set(1);
            AliyunPush.onMessage(function (info) {

                cordova.plugins.notification.badge.hasPermission(function (granted) {
                    if (granted) {
                        cordova.plugins.notification.badge.increase(1, function (badges) { });
                    }
                });

                if (app.ifm) {
                    app.ifm.onInterface({
                        cmd: 'PushMessageSuccess',
                        value: JSON.stringify(info)
                    });
                }
                else {
                    app.msgArr.push(info);
                }
            });
        });

        $("#loadings").show();
        that = this;
       // window.screen.lockOrientation('portrait');
        window.addEventListener("orientationchange", function () {
            app.ifm.onInterface({
                cmd: 'orientationchange',
                value: screen.orientation.type
            })
        });
        cordova.getAppVersion.getAppName().then(function (version) {
            var versionArr = version.split('_');
            if (versionArr.length > 1) {
                app.UType = version.split('_')[1];

            }
        });
        document.addEventListener("offline", app.Onoffline, false);

        document.addEventListener("online", app.Ononline, false);

        var networkState = navigator.connection.type;

        if (networkState == Connection.NONE) {
            $("#mainHtml").attr("src", 'file:///android_asset/www/index/index.html');
            $("#loadings").hide();
            $("#loadings").html('');
            app.netWork = Connection.NONE;
            app.loadBool = false;
        } else {
            cordova.plugins.AliRtcPlugin.isPad("", function (infos) {
                if (infos.isPad) {
                   // app.changePhone();
                    app.changeiPad();
                } else {
                    app.changePhone();
                }
                app.changeAfter();
            }, function (err) {
                app.changePhone();
                app.changeAfter();
            });
        }
    }
};
app.initialize();
